import itertools
from collections import Counter, defaultdict

def find_straight(many):
    run_next = None
    have_ace = False
    for key, _ in itertools.groupby(many):
        if key == 14:
            have_ace = True
        if run_next == key:
            if run_length == 4 or run_length == 3 and key == 2 and have_ace:
                return run_next + run_length
        else:
            run_length = 0
        run_length += 1
        run_next = key - 1

# GOD THIS FLUMMERY IS SO TARNATION ANNOYING
def eval_hand(cards):
    cards.sort(reverse=True)
    ranks = [card[0] for card in cards]

    # flushes
    by_suit = defaultdict(list)
    for card in cards:
        suit = by_suit[card[1]]
        suit.append(card[0])
        if len(suit) == 5:
            # FLUSH!
            if straight := find_straight(suit):
                # STRAIGHT FLUSH!!!
                return [5], straight
            return [3, 1.75], suit

    # straights
    if straight := find_straight(ranks):
        return [3, 1.25], straight

    # everything else
    counts = []
    values = []
    s = 0
    for value, count in Counter(ranks).most_common():
        count = min(count, 5-s)
        if not count:
            break
        s += count
        counts.append(count)
        values.append(value)
    return counts, values

def entry(hands, commune, out_of_play=()):
    deck = set(itertools.product(range(2, 15), "HDCS"))
    deck.difference_update(out_of_play)
    deck.difference_update(commune)
    for hand in hands:
        deck.difference_update(hand)

    c = 0
    winners = Counter()
    for rest in itertools.combinations(deck, 5 - len(commune)):
        c += 1
        best_hand = None
        winner = None
        for idx, hand in enumerate(hands):
            us = eval_hand([*commune, *rest, *hand]) 
            if not best_hand or us > best_hand:
                best_hand = us
                winner = idx
            elif us == best_hand:
                winner = None
        if winner is not None:
            winners[winner] += 1

    return {x: y / c for x, y in winners.items()}
